"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var debug = require('./log').debug;
var CREDENTIALS_PATH = require('./constants').CREDENTIALS_PATH;
var checkCredentialsPathExist = function () {
    debug('checking credentials path exist');
    var fileExists = fs_1.default.existsSync(CREDENTIALS_PATH);
    if (fileExists) {
        debug('Credentials path exist');
    }
    else {
        debug('creating the default path');
        var dirPath = path_1.default.dirname(CREDENTIALS_PATH);
        fs_1.default.mkdirSync(dirPath, { recursive: true });
        debug('Successfully created the path', dirPath);
        fs_1.default.writeFileSync(CREDENTIALS_PATH, '');
        debug('Successfully created file');
    }
};
exports.default = checkCredentialsPathExist;
