#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var minimist_1 = __importDefault(require("minimist"));
var markAsanaTaskCompleted_1 = __importDefault(require("./markAsanaTaskCompleted"));
var getAsanaTaskFromGithubPr_1 = __importDefault(require("./getAsanaTaskFromGithubPr"));
var promptTaskIdsAndGithubPR_1 = __importDefault(require("./promptTaskIdsAndGithubPR"));
var getTaskIdsForAsana_1 = __importDefault(require("./getTaskIdsForAsana"));
var checkCredentialsPathExist_1 = __importDefault(require("./checkCredentialsPathExist"));
var log_1 = require("./log");
var listGithubPrs_1 = __importDefault(require("./actions/listGithubPrs"));
var getToken_1 = __importStar(require("./getToken"));
var argv = minimist_1.default(process.argv.slice(2));
var performAsanaGithubAutomation = function () { return __awaiter(void 0, void 0, void 0, function () {
    var taskIds, githubPRLink, asanaToken;
    var _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4 /*yield*/, getToken_1.default({
                    type: getToken_1.TokenType.ASANA_TOKEN,
                    label: 'asana',
                })];
            case 1:
                asanaToken = _c.sent();
                if (!argv.githubPR) return [3 /*break*/, 3];
                return [4 /*yield*/, getAsanaTaskFromGithubPr_1.default(argv.githubPR)];
            case 2:
                (_a = _c.sent(), taskIds = _a.taskIds, githubPRLink = _a.githubPRLink);
                return [3 /*break*/, 5];
            case 3: return [4 /*yield*/, promptTaskIdsAndGithubPR_1.default()];
            case 4:
                (_b = _c.sent(), taskIds = _b.taskIds, githubPRLink = _b.githubPRLink);
                _c.label = 5;
            case 5:
                if (!(taskIds.length === 0)) return [3 /*break*/, 7];
                log_1.info("Could not found any task associated with the github pr link - " + githubPRLink);
                return [4 /*yield*/, getTaskIdsForAsana_1.default({ asanaToken: asanaToken, onlyMy: argv.onlyMe })];
            case 6:
                taskIds = _c.sent();
                if (!taskIds || taskIds.length === 0) {
                    process.exit();
                }
                _c.label = 7;
            case 7: return [4 /*yield*/, markAsanaTaskCompleted_1.default({ taskIds: taskIds, githubPRLink: githubPRLink, asanaToken: asanaToken })];
            case 8:
                _c.sent();
                return [2 /*return*/];
        }
    });
}); };
function cli() {
    return __awaiter(this, void 0, void 0, function () {
        var err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 5, , 6]);
                    checkCredentialsPathExist_1.default();
                    if (!argv.githubListPrs) return [3 /*break*/, 2];
                    return [4 /*yield*/, listGithubPrs_1.default(argv)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, performAsanaGithubAutomation()];
                case 3:
                    _a.sent();
                    _a.label = 4;
                case 4: return [3 /*break*/, 6];
                case 5:
                    err_1 = _a.sent();
                    log_1.error(err_1.message);
                    process.exit(0);
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    });
}
cli();
