"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var enquirer_1 = __importDefault(require("enquirer"));
var parse_github_url_1 = __importDefault(require("parse-github-url"));
var rest_1 = require("@octokit/rest");
var get_urls_1 = __importDefault(require("get-urls"));
var getToken_1 = __importStar(require("./getToken"));
var log_1 = require("./log");
var asana_1 = require("./utils/asana");
var ASANA_DOMAIN = 'app.asana.com';
var parseGithubUrl = function (prLink) {
    var parsedUrl = parse_github_url_1.default(prLink);
    log_1.debug('Successfully parsed the github url');
    if (!parsedUrl) {
        throw new Error('Github url could not be parsed. Please check the github url.');
    }
    if (!(parsedUrl.owner && parsedUrl.name && parsedUrl.filepath)) {
        throw new Error('Github url could not be parsed. Please check the github url.');
    }
    return {
        owner: parsedUrl.owner,
        name: parsedUrl.name,
        filePath: Number(parsedUrl.filepath),
    };
};
function main(githubPR) {
    return __awaiter(this, void 0, void 0, function () {
        var githubToken, octokit, prLink, _a, parsedUrl, _b, url, prBody, urls, asanaLinks, asanaTaskIds;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, getToken_1.default({
                        type: getToken_1.TokenType.GITHUB_TOKEN,
                        label: 'github ',
                    })];
                case 1:
                    githubToken = _c.sent();
                    octokit = new rest_1.Octokit({
                        auth: githubToken,
                    });
                    if (!!githubPR) return [3 /*break*/, 3];
                    return [4 /*yield*/, enquirer_1.default.prompt({
                            type: 'input',
                            name: 'prLink',
                            message: 'Please enter the PR link:',
                        })];
                case 2:
                    _a = _c.sent();
                    return [3 /*break*/, 4];
                case 3:
                    _a = { prLink: githubPR };
                    _c.label = 4;
                case 4:
                    prLink = (_a).prLink;
                    log_1.debug('Successfully got the pr link', prLink);
                    parsedUrl = parseGithubUrl(prLink);
                    log_1.debug('Successfully parsed the github url');
                    if (!parsedUrl) {
                        throw new Error('Github url could not be parsed. Please check the github url.');
                    }
                    return [4 /*yield*/, octokit.pulls.get({
                            owner: parsedUrl.owner,
                            repo: parsedUrl.name,
                            pull_number: parsedUrl.filePath,
                        })];
                case 5:
                    _b = _c.sent(), url = _b.url, prBody = _b.data.body;
                    log_1.debug('Successfully fetched the pull request', url);
                    urls = Array.from(get_urls_1.default(prBody || ''));
                    log_1.debug('Successfully fetched the urls from pull request', urls);
                    asanaLinks = urls.filter(function (url) { return url.includes(ASANA_DOMAIN); });
                    if (asanaLinks.length === 0) {
                        return [2 /*return*/, { taskIds: [], githubPRLink: prLink }];
                    }
                    log_1.debug('Successfully filtered asana links', asanaLinks);
                    asanaTaskIds = asana_1.getTaskIdsFromUrls(asanaLinks);
                    log_1.debug('Successfully fetched the task ids', asanaTaskIds);
                    return [2 /*return*/, { taskIds: asanaTaskIds, githubPRLink: prLink }];
            }
        });
    });
}
exports.default = main;
