"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAsanaClient = exports.getTaskIdsFromUrls = void 0;
var asana_1 = __importDefault(require("asana"));
var URL_SEPARATOR = '/';
var isLinkForFullScreen = function (asanaLinkParts) {
    return asanaLinkParts[0] === 'f';
};
var getTaskIdsFromUrls = function (asanaLinks) {
    var asanaTaskIds = asanaLinks.map(function (link) {
        var linkParts = link.split(URL_SEPARATOR).reverse();
        return linkParts[isLinkForFullScreen(linkParts) ? 1 : 0];
    });
    return asanaTaskIds;
};
exports.getTaskIdsFromUrls = getTaskIdsFromUrls;
var getAsanaClient = function (asanaToken) {
    var asanaClient = asana_1.default.Client.create().useAccessToken(asanaToken);
    return asanaClient;
};
exports.getAsanaClient = getAsanaClient;
